# Form Builder

This is a configuration section of [Custom MT](/advanced/custom-mt.md). Use this configuration to create Machine Translation settings forms with various form elements.

## Object Structure

* **type**: `string`
  * "string"
  * "number"
  * "object"
* **form**: `string`
  * "input-text"
  * "input-number"
  * "input-range"
  * "input-password"
  * "select"
  * "textarea"
* **name**: `string`
* **title**: `string`
* **default**: `string|number`
* **options**: `Array of objects` <{name: string, value: string}> <mark style="color:$warning;">(optional)</mark>
* **styles**: `object` (optional)
* **launcher**: `object` \<show: boolean, fullwidth: boolean> <mark style="color:$warning;">(optional)</mark>

```json
{
    "formBuilder": [
        { "type": "string", "form": "input-text", "name": "api_key", "title": "API Key*", "default": "",
            "launcher": { "show": true }
        },        
        { "type": "string", "form": "select", "name": "formality", "title": "Formality", "default": "default",
            "options": [
                { "name": "Default", "value": "default" },
                { "name": "Formal", "value": "more" },
                { "name": "Informal", "value": "less" },
                { "name": "Formal (if available)", "value": "prefer_more" },
                { "name": "Informal (if available)", "value": "prefer_less" }
            ],
            "launcher": { "show": true }
        },
        { "type": "string", "form": "select", "title": "Preserve Formatting", "name": "preserve_formatting", "default": "0",
            "options": [
                { "name": "No (default)", "value": "0" },
                { "name": "Yes", "value": "1" }
            ],
            "launcher": { "show": true }
        }
    ]
}
```


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.vntranslator.com/advanced/custom-mt/form-builder.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
